#pragma once

struct REALstringStruct;
typedef REALstringStruct *REALstring;

#define REALexportPPC 1

struct REALexport
{
	const char *entryName;
	void *proc;
	int flags;
};

struct REALmethodDefinition
{
	int exportIndex;
	const char *declaration;
};

#define REALpropInvalidate 1

struct REALproperty
{
	const char *group;
	const char *name;
	const char *type;
	int flags;
	int propertyOffset;
};

struct REALevent
{
	const char *declaration;
	int forSystemUse;
};

struct REALcontrolBehaviour
{
	REALexport *initFunction;
	REALexport *disposeFunction;
	REALexport *redrawFunction;
	REALexport *clickFunction;
	REALexport *mouseDragFunction;
	REALexport *mouseUpFunction;
	REALexport *gainedFocusFunction;
	REALexport *lostFocusFunction;
	REALexport *keyDownFunction;
	REALexport *unusedFunction0;
	REALexport *unusedFunction1;
	REALexport *unusedFunction2;
	REALexport *unusedFunction3;
	REALexport *unusedFunction4;
	REALexport *unusedFunction5;
	REALexport *unusedFunction6;
	REALexport *unusedFunction7;
	REALexport *unusedFunction8;
	REALexport *unusedFunction9;
	REALexport *unusedFunction10;
	REALexport *unusedFunction11;
	REALexport *unusedFunction12;
};

#define kCurrentREALControlVersion 1

#define REALcontrolAcceptFocus 1
#define REALcontrolFocusRing 2
#define REALinvisibleControl 4

struct REALcontrol
{
	int version;
	const char *name;
	int dataSize;
	int flags;
	int toolbarPICT, toolbarDownPICT;
	REALproperty *properties;
	int propertyCount;
	REALmethodDefinition *methods;
	int methodCount;
	REALevent *events;
	int eventCount;
	REALcontrolBehaviour *behaviour;
	int forSystemUse;
};

#define FieldOffset(type, field) (long)(&((type *) 0)->field)

struct REALcontrolInstanceStruct;
typedef REALcontrolInstanceStruct *REALcontrolInstance;

struct REALfolderItemStruct;
typedef REALfolderItemStruct *REALfolderItem;

struct REALgraphicsStruct;
typedef REALgraphicsStruct *REALgraphics;

struct REALpictureStruct;
typedef REALpictureStruct *REALpicture;

struct REALsoundStruct;
typedef REALsoundStruct *REALsound;

struct REALappleEventStruct;
typedef REALappleEventStruct *REALappleEvent;

struct REALwindowStruct;
typedef REALwindowStruct *REALwindow;

struct REALpopupMenuStruct;
typedef REALpopupMenuStruct *REALpopupMenu;

extern "C" {
void PluginEntry(void);
extern short pluginExportCode;
extern REALexport pluginExports[];
}
