#include "REALplugin.h"

void REALRegisterMethod(REALmethodDefinition *defn);
void REALRegisterControl(REALcontrol *defn);

void REALLockString(REALstring str);
void REALUnlockString(REALstring str);

const char *REALCString(REALstring str);
const unsigned char *REALPString(REALstring str);

REALstring REALBuildString(const char *contents, int length);

REALpicture REALBuildPictureFromPicHandle(PicHandle pic, Boolean bPassOwnership);
REALpicture REALBuildPictureFromGWorld(GWorldPtr world, Boolean bPassOwnership);

REALfolderItem REALFolderItemFromFSSpec(const FSSpec *spec);
Boolean REALFSSpecFromFolderItem(FSSpec *spec, REALfolderItem item);

REALsound REALBuildSoundFromHandle(Handle sound, Boolean bPassOwnership);

REALappleEvent REALBuildAppleEvent(const AppleEvent *event, Boolean bPassOwnership);
REALappleEvent REALBuildAEDescList(const AppleEvent *event, Boolean bPassOwnership);
REALappleEvent REALBuildAEObjSpecifier(const AppleEvent *event, Boolean bPassOwnership);
AppleEvent *REALAccessAppleEvent(REALappleEvent event);
AppleEvent *REALAccessAppleEventReply(REALappleEvent event);

WindowPtr REALGetWindowHandle(REALwindow window);
ControlHandle REALGetControlHandle(REALcontrolInstance control);
MenuHandle REALGetPopupMenuHandle(REALpopupMenu popup);

void GraphicsDrawLine(Ptr graphicsObject, int x1, int y1, int x2, int y2);

void *REALGetControlData(REALcontrolInstance instance, REALcontrol *defn);
void REALGetControlBounds(REALcontrolInstance instance, Rect *rBounds);

void *REALGetEventInstance(REALcontrolInstance instance, REALevent *event);

void REALSelectGraphics(REALgraphics context);

#define ControlData(defn, instance, typeName, data) typeName *data = (typeName *) REALGetControlData(instance, &defn)
